#!/usr/bin/env ruby
require 'cgi_exception'
require 'funciones'
require 'htm'
require 'datos'
require 'csv'
def listado(frm)
    pag = Pagina.new("Cobranzas a depositar", 4)
    boton("Exportar", "111018_bancos.rb?accion=exportar")
    boton("Volver", "geined.py?accion=contabilidad")
    filas_por_pagina = 20
    pagina_actual = 1
    if frm.has_key?('pagina')
        pagina_actual = frm['pagina']
    end
    cuenta = Cuenta.find(:first, :conditions=>{:rubro=>'111018'})
    off_set = (pagina_actual.to_i - 1) * filas_por_pagina
    tot_debe = Transaccion.sum(:debe, :conditions=>{:cuenta_id=>cuenta.id})
    tot_haber = Transaccion.sum(:haber, :conditions=>{:cuenta_id=>cuenta.id})
    tot_saldo = tot_haber - tot_debe
    puts pag.cgi.table{
        pag.cgi.tr{
            pag.cgi.th{'Debe'} +
            pag.cgi.th{'Haber'} +
            pag.cgi.th{'Saldo'}
        } +
        pag.cgi.tr{
            pag.cgi.td('align'=>'right'){moneda(tot_debe)} +
            pag.cgi.td('align'=>'right'){moneda(tot_haber)} +
            pag.cgi.td('align'=>'right'){moneda(tot_saldo)}
        }
    }
    total_filas = Transaccion.find(:all, :conditions=>{:cuenta_id=>cuenta.id}).size
    total_paginas = total_filas / filas_por_pagina
    transacciones = Transaccion.find(
        :all, :conditions=>{:cuenta_id=>cuenta.id},
        :limit=>filas_por_pagina,
        :offset=>off_set,
        :order=>:id)
    i = 0
    saldo = 0
    encabezado_tabla(["Nº", "Fecha", "Detalle", "Debe", "Haber", "Saldo"])
    transacciones.each do |fila|
        fila_alterna(i)
        celda(fila.id)
        celda(mysql_a_fecha(fila.fecha))
        celda(fila.detalle)
        linea_moneda(fila.debe)
        linea_moneda(fila.haber)
        saldo = saldo + fila.haber - fila.debe
        linea_moneda(saldo)
        i = i + 1
    end
    fin_tabla
    navegador('111018_bancos.rb?accion=listado', pagina_actual, total_paginas)
    boton('Volver', 'geined.py?accion=direccion')
    pag.fin
end
def exportar
    cuenta = Cuenta.find(:first, :conditions=>{:rubro=>'111018'})
    transacciones = Transaccion.find(:all,
        :conditions=>{:cuenta_id => cuenta.id},
        :order=>:fecha)
    filename = StringIO.new
    saldo = 0
    sum_debe = 0
    sum_haber = 0
    CSV::Writer.generate(filename) do |bancos_csv|
        bancos_csv <<(["Nº", "Fecha", "Detalle", "Debe", "Haber", "Saldo"])
        transacciones.each do |fila|
            saldo = saldo +  fila.haber - fila.debe
            sum_debe = sum_debe + fila.debe
            sum_haber = sum_haber + fila.haber
            bancos_csv << [fila.id,
                mysql_a_fecha(fila.fecha),
                fila.detalle,
                fila.debe.to_s.gsub(".",","),
                fila.haber.to_s.gsub(".",","),
                saldo.to_s.gsub(".",",")]
        end
        bancos_csv << ["","","Total",
            sum_debe.to_s.gsub(".",","),
            sum_haber.to_s.gsub(".",","),
            saldo.to_s.gsub(".",",")]
    end
    filename.rewind
    puts "Content-Type: text/csv"
    puts "Content-Disposition: attachment; filename=\"bancos.csv\""
    puts ""
    filename.each do |fila|
        puts fila
    end
end
if __FILE__ == $0
    form = CGI.new("html4")
    accion = 'listado'
    if form.has_key?('accion')
        accion = form['accion']
    end
    case accion
    when 'listado'
        listado(form)
    when 'exportar'
        exportar
    end
end
