#!/usr/bin/env ruby
require 'funciones'
require 'datos'
require 'htm'
def listado(frm)
  pag = Pagina.new('Listado de alumnos', 10)
  puts pag.cgi.form('post', 'alu.rb'){
    pag.cgi.hidden('accion', 'listado') +
      ' Nombre:' + pag.cgi.text_field('nombre') +
      '  CI: ' + pag.cgi.text_field('ci') +
      '  y Sucursal:' +
    pag.cgi.popup_menu('sucursal', ['','Cualquiera', true], ['CA', 'Carrasco'], ['CO','Costa']) +
    pag.cgi.submit('Buscar')
  }
  boton('Alumnos x Sucursal', 'alu_suc.py')
  boton('Volver', 'geined.py?accion=academico')
  puts '<br/>'
  nombre = frm['nombre']
  ci = frm['ci']
  sucursal = frm['sucursal']
  alumnos = Alumno.find(:all, :conditions=>{:finalizado=>nil})
  encabezado_tabla(['Nº', 'Alumno', 'CI','Curso', 'Tipo de pago', 'Cuota','Acciones'])
  i = 0
  alumnos.each do |fila|
    flag = true
    cliente = Cliente.find(fila.cliente_id)
    begin
      curso = Curso.find(fila.curso_id)
      nombre_curso = curso.curso
    rescue ActiveRecord::RecordNotFound
      nombre_curso = "Desconocido"
    end
    if nombre.size > 0
      if not cliente.nombre.include? nombre
        flag = false
      end
    end
    if ci.size > 0
      if not cliente.ci.include? ci
        flag = false
      end
    end
    if sucursal.size > 0
      if curso.curso[0..1] != sucursal
        flag = false
      end
    end
    if flag == true
      fila_alterna(i)
      celda(fila.id)
      celda(cliente.nombre)
      celda(cliente.ci)
      celda(nombre_curso)
      tipo_pago = Tipo_pago.find(fila.tipo_pago_id)
      celda(tipo_pago.tipo)
      linea_moneda(fila.cuota)
      puts '<td>'
      boton_editar("alu.rb?accion=editar&id=#{fila.id}")
      boton(:Cliente, "cli_ver?id=#{fila.cliente_id}")
      boton(:Curso, "cur_ver.py?id=#{fila.curso_id}")
      boton_confirmar('Drop-out', '¿Desea dar de baja a este alumno?', "alu.rb?accion=drop-out&id=#{fila.id}")
      boton_eliminar("alu.rb?accion=eliminar&id=#{fila.id}")
      puts '</td></tr>'
      i = i + 1
    end
  end
  fin_tabla
  boton('Volver', 'geined.py?accion=academico')
  pag.fin
end
def nuevo
    pag = Pagina.new('Inscripción', 5)
    nota('Una vez que guarda estos datos, el cliente pasa a la categoría Alumno')
    form_edicion('Inscribir cliente', 'alu.rb')
    puts pag.cgi.hidden('accion', 'agregar')
    clientes = Cliente.find(:all, :order=>:nombre)
    cursos = Curso.find(:all, :order=>:curso)
    tipo_pago = Tipo_pago.find(:all, :order=>:tipo)
    input_combo('Cliente:', 'cliente_id', clientes, ['id', 'nombre'], '')
    input_combo('Curso:', 'curso_id', cursos, ['id', 'curso'], '')
    input_combo('Tipo de pago:', 'tipo_pago_id', tipo_pago, ['id', 'tipo'], '')
    input_texto('Cuota:', 'cuota', '')
    input_numero('Cuotas pagas:', 'pago', '')
    botones('alu.rb?accion=listado')
    pag.fin
end
def agregar(frm)
  Alumno.create(
    :cliente_id => frm['cliente_id'],
    :curso_id => frm['curso_id'],
    :tipo_pago_id => frm['tipo_pago_id'],
    :cuota => frm['cuota'],
    :pago => frm['pago']
  )
  # Pasar cliente a categoría alumno
  cli = Cliente.find(frm['cliente_id'])
  cli.categoria_id = 2
  cli_save
  listado(frm)
end
def editar(frm)
  pag = Pagina.new('Editar alumno', 5)
  form_edicion('Editar alumno', 'alu.rb')
  alumno = Alumno.find(:first, :conditions=>{:id=>frm['id']})
  cliente = Cliente.find(:first, :conditions=>{:id=>alumno.cliente_id})
  cursos = Curso.find(:all, :conditions=>{:finalizado=>nil})
  tipo_pago = Tipo_pago.all
  puts pag.cgi.hidden('accion', 'actualizar') +
    pag.cgi.hidden('id', frm['id'])
  input_label('Nombre', cliente.nombre)
  input_combo('Curso:', 'curso_id', cursos, ["id", "curso"], alumno.curso_id)
  input_combo("Tipo de pago:", "tipo_pago_id", tipo_pago, ["id", "tipo"], alumno.tipo_pago_id)
  input_numero("Cuota:", "cuota", alumno.cuota)
  input_numero("Cuotas pagas:", "pago", alumno.pago)
  botones("alu.rb?accion=listado")
  form_edicion_fin
  pag.fin
end
def actualizar(frm)
  id = frm['id']
  alumno = Alumno.find(id)
  alumno.curso_id = frm['curso_id']
  alumno.tipo_pago_id = frm['tipo_pago_id']
  alumno.cuota = frm['cuota']
  alumno.pago = frm['pago']
  alumno.save
  listado(frm)
end
def reporte
    encabezado_tabla(['Filtrar por sucursal'])
    formulario('alu_suc.py')
    puts '<tr><td>Sucursal:
        <INPUT TYPE="radio" NAME="suc" VALUE="Costa"> Costa
        <INPUT TYPE="radio" NAME="suc" VALUE="Carrasco"> Carrasco
        <INPUT TYPE="submit" VALUE="Ver"></TD></tr>'
    fin_formulario
    fin_tabla
end
def drop_out(frm)
  id = frm['id']
  alumno = Alumno.find(id)
  cliente_id = alumno.cliente_id
  # verificar antes si es alumno de más de un curso
  inscripciones = Alumno.find(:all, :conditions=>{:cliente_id=>cliente_id})
  if inscripciones.size <= 1
    clientes = Cliente.find(cliente_id)
    clientes.categoria_id = 1
    clientes.save
  end
  alumno.finalizado = 1
  alumno.save
  listado(frm)
end
def eliminar(frm)
  # elimina el alumno
  # no cambia al cliente porque supuestamente no es un drop-out
  alumno = Alumno.find(frm['id'])
  alumno.delete
  listado(frm)
end
if __FILE__ == $0
  form = CGI.new()
  if not form.has_key?('accion')
    accion = 'listado'
  else
    accion = form['accion']
  end
  case accion
  when 'listado'
    listado(form)
  when 'nuevo'
    nuevo
  when 'agregar'
    agregar(form)
  when 'editar'
    editar(form)
  when 'actualizar'
    actualizar(form)
  when 'eliminar'
    eliminar(form)
  when 'drop-out'
    drop_out(form)
  end
end
