#!/usr/bin/env python
# -*- coding: utf-8 -*-
"""Manejo de BIENES DE CAMBIO"""
import cgitb; cgitb.enable()
import cgi
import htm
import datos
import pagina
import funciones

def listado():
    """Listado de bienes de cambio"""
    pag = pagina.Pagina("Listado de Bienes de Cambio", 5)
    print(htm.button("Nuevo", "biecam.py?accion=nuevo"))
    print(htm.button('Volver', 'geined.py?accion=direccion'))
    # cargar datos
    bie_cam = datos.Tabla("bie_cam")
    bie_cam.filtrar()
    existencias = datos.Tabla("existencias")
    htm.encabezado_tabla(["Nº", "Descripción", "Precio", "Cantidad", "Acciones"])
    i = 0
    for fila in bie_cam.resultado:
        htm.fila_alterna(i)
        biecam_id = str(fila['id'])
        print(htm.td(biecam_id))
        print(htm.td(fila['descripcion']))
        print(htm.td(funciones.moneda(fila['precio']), "right"))
        existencias.filtro = "bie_cam_id = " + biecam_id
        existencias.filtrar()
        if not existencias.encontrado:
            cantidad = 0
        cantidad = existencias.num_filas
        print(htm.td(cantidad))
        print('<td>')
        htm.boton_detalles('biecam.py?accion=ver&id=' + biecam_id)
        htm.boton_editar('biecam.py?accion=editar&id=' + biecam_id)
        htm.boton_eliminar('biecam.py?accion=eliminar&id=' + biecam_id)
        print('</td>')
        i = i + 1
    htm.fin_tabla()
    print(htm.button('Volver', 'geined.py?accion=direccion'))
    pag.fin()
def nuevo():
    """Formulario nuevo ítem BC"""
    pag = pagina.Pagina("Nuevo ítem en Bienes de Cambio")
    htm.form_edicion("biecam.py?accion=agregar")
    htm.input_texto("Descripción:", "descripcion", "")
    htm.input_numero("Precio:", "precio", "")
    htm.botones("biecam.py?accion=listado")
    htm.form_edicion_fin()
    pag.fin()

def agregar(frm):
    """Inserta un item de BC en la BDD"""
    pag = pagina.Pagina("Insertando datos")
    bie_cam = datos.Tabla("bie_cam")
    bie_cam.buscar("descripcion", frm.getvalue("descripcion"))
    if encontrado:
        htm.duplicado("biecam.py?accion=listado")
    else:
        bie_cam.registro["descripcion"] = frm.getvalue("descripcion")
        bie_cam.registro["precio"] = frm.getvalue("precio")
        bie_cam.insertar()
    htm.redirigir("biecam.py?accion=listado")
    pag.fin()
def editar(frm):
    """Edición de ítem de Bienes de cambio"""
    pag = pagina.Pagina("Edición de ítem en Bienes de Cambio", 5)
    bie_cam = datos.Tabla("bie_cam")
    bie_cam.buscar("id", frm.getvalue("id"))
    htm.form_edicion("biecam.py?accion=actualizar")
    htm.campo_oculto("id", bie_cam.registro["id"])
    htm.input_texto("Descripción:", "descripcion", bie_cam.registro["descripcion"])
    htm.input_numero("Precio:", "precio", bie_cam.registro["precio"])
    htm.botones("biecam.py?accion=listado")
    htm.form_edicion_fin()
    pag.fin()

def actualizar(frm):
    """Actualizar ítem de Bienes de Cambio"""
    pag = pagina.Pagina("Actualizando", 10)
    bie_cam = datos.Tabla("bie_cam")
    bie_cam.buscar("id", frm.getvalue("id"))
    bie_cam.registro["descripcion"] = frm.getvalue("descripcion")
    bie_cam.registro["precio"] = frm.getvalue("precio")
    bie_cam.actualizar()
    htm.redirigir("biecam.py?accion=listado")
    pag.fin()

def detalle(frm):
    """Detalles de un item de Bienes de cambio"""
    # Recuperar variables
    id = frm.getvalue("id")
    # datos
    existencias = datos.Tabla("existencias")
    bie_cam = datos.Tabla("bie_cam")
    depositos = datos.Tabla("depositos")
    # Pagina
    pag = pagina.Pagina("Existencias de Bienes de Cambio", 5)
    print(htm.button("Ingresar a stock", "biecam.py?accion=ingstock&id=" + str(id)))
    bie_cam.buscar("id", id)
    print(htm.h2(bie_cam.registro["descripcion"]))
    htm.encabezado_tabla(["Sucursal", "Cantidad", "Acciones"])
    existencias.buscar("biecam_id", id)
    i = 0
    for fila in existencias.resultado:
        htm.fila_alterna(i)
        depositos.buscar("id", fila["deposito_id"])
        print(htm.td(fila["deposito"]))
        print(htm.td(fila["cantidad"]))
        print("<td>")
        print(htm.button("Ajustar", "biecam.py?accion=ajustar&id=" + str(fila['id'])))
        print(htm.button("Transferir", 'biecam.py?accion=transferir&id=' + str(fila['id'])))
        print('</td></tr>')
    htm.fin_tabla()
    print(htm.button('Volver', 'biecam.py?accion=listado'))
    pag.fin()
def ing_stock(frm):
    """Ingresar Stock"""
    # Recuperar variables
    id = frm.getvalue("id")
    # VOY POR ACA
    fil_bie = buscar_registro("bie_cam","id",id)
    bien = fil_bie['descripcion']
    # Preparar combo box
    sql_dep = "SELECT * FROM depositos"
    res_dep = mysql_query(sql_dep)
    htm.encabezado("Ingresar bienes a stock")
    print(htm.h3(bien))
    htm.formulario("biecam.php?accion=ingresar&biecam_id=$id")
    htm.encabezado_tabla(["Campo","Valor"])
    htm.input_combo("Sucursal:","deposito_id", res_dep, "")
    htm.input_numero("Cantidad:","cantidad","")
    htm.fin_tabla()
    htm.botones()
    htm.fin_formulario()
    htm.button("Volver","biecam.php?accion=listado")
    pag.fin()
def ingresar(frm):
    # Recuperación de variables
    biecam_id = frm.getvalue('biecam_id')
    deposito_id = frm.getvalue('deposito_id')
    cantidad = frm.getvalue('cantidad')
    # Detección de duplicados
    existencias = datos.Tabla("existencias")
    # existencias.buscar("deposito_id", deposito_id)
    sql_dup = "SELECT * FROM existencias WHERE deposito_id=$deposito_id AND biecam_id=$biecam_id"
    res_dup = mysql_query(sql_dup)
    if(mysql_num_rows(res_dup)==0):
        # Armar SQL
        sql = "INSERT INTO existencias SET deposito_id = 'deposito_id', cantidad = 'cantidad', biecam_id = 'biecam_id'"
        res = mysql_query(sql)
        # Redirigir
        redirigir("biecam.php?accion=ver&id=$biecam_id")
    else:
        duplicado("biceam.php?accion=ver&id=$biecam_id")
def ajustar(frm):
    """Actualizar existencias"""
    pag = pagina.Pagina("Actualizar existencias", 5)
    htm.formulario("biecam.py?accion=act_exi")
    htm.encabezado_tabla(["Campo", "Valor"])
    id = frm.getvalue('id')
    fil_exi = buscar_registro("existencias", "id", id)
    deposito_id = fil_exi['deposito_id']
    fil_suc = buscar_registro("depositos", "id", deposito_id)
    sucursal = fil_suc['deposito']
    print(htm.hidden("id",id))
    print(htm.hidden("biecam_id",fil_exi['biecam_id']))
    print(htm.tr(htm.td("Sucursal:") + htm.td(sucursal)))
    htm.input_numero("Cantidad:","cantidad",fil_exi['cantidad'])
    htm.fin_tabla()
    htm.botones()
    htm.fin_formulario()
    pag.fin()
def act_exi(frm):
    id = frm.getvalue('id')
    cantidad = frm.getvalue('cantidad')
    biecam_id = frm.getvalue('biecam_id')
    sql = "UPDATE existencias SET cantidad='$cantidad' WHERE id='$id'"
    res = mysql_query(sql)
    redirigir("biecam.php?accion=ver&id=$biecam_id")
def transferir(frm):
    id = frm.getvalue('id')
    sql_dep = "SELECT * FROM depositos"
    res_dep = mysql_query(sql_dep)
    encabezado("Transferir bienes de cambio")
    formulario("biecam.php?accion=acttra")
    campo_oculto("id", id)
    encabezado_tabla(array("Campo","Valor"))
    input_combo("Tansferir hasta:","hasta",res_dep,"")
    input_numero("Cantidad a transferir:","cantidad","")
    fin_tabla()
    botones()
    fin_formulario()
    fin()
def acttra(frm):
    id = frm.getvalue('id')
    cantidad_a_transferir = frm.getvalue('cantidad')
    fil_exi = buscar_registro("existencias","id",id)
    origen = fil_exi['deposito_id']
    destino = frm.getvalue('hasta')
    biecam_id = fil_exi['biecam_id']
    pre_origen = fil_exi['cantidad']
    sql_destino = "SELECT * FROM existencias WHERE deposito_id='$destino' AND biecam_id='$biecam_id'"
    res_destino = mysql_query(sql_destino)
    if (mysql_num_rows(res_destino)==0):
        sql_trans = "INSERT INTO existencias SET deposito_id='$destino', cantidad='$cantidad_a_transferir', biecam_id = '$biecam_id'"
        res = mysql_query(sql_trans)
        saldo_origen = pre_origen - cantidad_a_transferir
        sql_trans2 = "UPDATE existencias SET cantidad ='$saldo_origen' WHERE id='$id'"
        res = mysql_query(sql_trans2)
    else:
        fil_destino = mysql_fetch_array(res_destino)
        pre_destino = fil_destino['cantidad']
        id_destino = fil_destino['id']
        saldo_origen = pre_origen - cantidad_a_transferir
        saldo_destino = pre_destino + cantidad_a_transferir
        sql_ori = "UPDATE existencias SET cantidad='$saldo_origen' WHERE id='$id'"
        res = mysql_query(sql_ori);
        sql_des = "UPDATE existencias SET cantidad='$saldo_destino' WHERE id='$id_destino'"
    redirigir("biecam.php?accion=ver&id=$biecam_id")
def main():
    """Programa principal"""
    form = cgi.FieldStorage()
    accion = 'listado'
    if form.has_key('accion'):
        accion = form.getvalue('accion')
    if accion == 'listado':
        listado()
    elif accion == 'listado':
        listado()
    elif accion == 'nuevo':
        nuevo()
    elif accion == 'agregar':
        agregar(form)
    elif accion == 'editar':
        editar(form)
    elif accion == 'actualizar':
        actualizar(form)
    elif accion == 'confirmar':
        confirmar_borrar(frm.getvalue('id'),'biecam.py')
    elif accion == 'eliminar':
        autorizacion(2)
        borrar('bie_cam', frm.getvalue('id'),'biecam.py')
    elif accion == 'ver':
        detalle(form)
    elif accion == 'ajustar':
        ajustar(form)
    elif accion == 'act_exi':
        act_exi(form)
    elif accion == 'transferir':
        transferir(form)
    elif accion == 'acttra':
        acttra(form)
    elif accion == 'ingstock':
        ing_stock(form)
    elif accion == 'ingresar':
        ingresar(form)
if __name__ == "__main__":
    main()
