#!/usr/bin/env ruby
require 'cgi_exception'
require 'cgi'
require 'funciones'
require 'htm'
require 'datos'

# Listado de bienes de cambio
def listado
    pag = Pagina.new('Listado de Bienes de Cambio', 5)
    boton('Nuevo', 'biecam.rb?accion=nuevo')
    boton('Volver', 'geined.py?accion=direccion')
    # cargar datos
    encabezado_tabla(['Nº', 'Descripción', 'Precio', 'Cantidad', 'Acciones'])
    i = 0
    bienes = Bie_cam.all(:order=>:descripcion)
    bienes.each do |fila|
        fila_alterna(i)
        celda(fila.id)
        celda(fila.descripcion)
        linea_moneda(fila.precio)
        cantidad = fila.existencias.sum(:cantidad)
        celda(cantidad)
        puts '<td>'
        boton_detalles("biecam.rb?accion=ver&id=#{fila.id}")
        boton_editar("biecam.rb?accion=editar&id=#{fila.id}")
        boton_eliminar("biecam.rb?accion=eliminar&id=#{fila.id}")
        puts '</td>'
        i = i + 1
    end
    fin_tabla
    boton('Volver', 'geined.py?accion=direccion')
    pag.fin
end
# Formulario nuevo ítem BC
def nuevo
    pag = Pagina.new('Nuevo ítem en Bienes de Cambio', 5)
    form_edicion('Nuevo ítem en Bienes de cambio', 'biecam.rb')
    puts pag.cgi.hidden('accion', 'agregar')
    input_texto('Descripción:', 'descripcion', '')
    input_numero('Precio:', 'precio', '')
    botones('biecam.rb?accion=listado')
    form_edicion_fin
    pag.fin
end
# Inserta un item de BC en la BDD
def agregar(frm)
    numero = Bie_cam.count(:conditions => {:descripcion=>frm['descripcion']})
    if numero == 0
        Bie_cam.create(
            :descripcion=>frm['descripcion'],
            :precio=>frm['precio'])
        listado
    else
        pag = Pagina.new('Registro duplicado', 10)
        duplicado('biecam.rb?accion=listado')
        pag.fin
    end
end
# Edita un ítem del stock
def editar(frm)
    pag = Pagina.new('Edición de ítem en Bienes de Cambio', 5)
    bienes = Bie_cam.find(frm['id'])
    form_edicion('Edición de ítem', 'biecam.rb')
    puts pag.cgi.hidden('accion', 'actualizar') +
        pag.cgi.hidden('id', bienes.id)
    input_texto('Descripción:', 'descripcion', bienes.descripcion)
    input_numero('Precio:', 'precio', bienes.precio)
    botones('biecam.rb?accion=listado')
    form_edicion_fin
    pag.fin
end
# Actualiza datos de un ítem del stock
def actualizar(frm)
    Bie_cam.update(frm['id'], {
        :descripcion=>frm['descripcion'],
        :precio=>frm['precio']})
    listado
end
# Detalles de un item de Bienes de cambio"""
def detalle(frm)
    # Recuperar variables
    id = frm['id']
    # datos
    bienes = Bie_cam.find(id)
    # Pagina
    pag = Pagina.new('Existencias de Bienes de Cambio', 5)
    boton('Ingresar a stock', "biecam.rb?accion=ingstock&id=#{id.to_s}")
    boton('Volver', 'biecam.rb?accion=listado')
    puts frm.h2{bienes.descripcion}
    encabezado_tabla(['Sucursal', 'Cantidad', 'Acciones'])
    i = 0
    bienes.existencias.each do |fila|
        fila_alterna(i)
        depositos = Deposito.find(fila.deposito_id)
        celda(depositos.deposito)
        celda(fila.cantidad)
        puts "<td>"
        boton("Ajustar", "biecam.rb?accion=ajustar&id=#{fila.id.to_s}")
        boton("Transferir", "biecam.rb?accion=transferir&id=#{fila.id.to_s}")
        boton_eliminar("biecam.rb?accion=eliminar_existencia&id=#{fila.id.to_s}")
        puts "</td></tr>"
    end
    fin_tabla
    boton('Volver', 'biecam.rb?accion=listado')
end
# Ingresar datos a stock
def ingstock(frm)
    # Recuperar variables
    id = frm['id']
    bienes = Bie_cam.find(:first, :conditions=>{:id=>id})
    depositos = Deposito.all
    pag = Pagina.new("Ingresar bienes a stock", 5)
    frm.h3{bienes.descripcion}
    form_edicion('Ingresar nuevo bien a stock', 'biecam.rb')
    puts pag.cgi.hidden('accion', 'ingresar') +
        pag.cgi.hidden('biecam_id', id)
    input_combo('Sucursal:', 'deposito_id', depositos, ['id', 'deposito'], '')
    input_numero('Cantidad:', 'cantidad', '')
    botones('biecam.rb?accion=listado')
    form_edicion_fin
    pag.fin
end
# Ingresar un bien a stock
def ingresar(frm)
    # Recuperación de variables
    biecam_id = frm['biecam_id']
    deposito_id = frm['deposito_id']
    cantidad = frm['cantidad']
    # Detección de duplicados
    registros = Existencia.count(:conditions => {
      :deposito_id=>deposito_id,
      :biecam_id =>biecam_id})
    if registros == 0
      Existencia.create(
        :deposito_id => deposito_id,
        :biecam_id => biecam_id,
        :cantidad => cantidad)
      Pagina.new("Dato ingresado")
      redirigir("biecam.rb?accion=ver&id=#{biecam_id}")
    else
      pag = Pagina.new('Registro duplicado')
      duplicado("biecam.rb?accion=ver&id=#{biecam_id}")
      pag.fin
    end
end
# Ajustad datos de existencias
def ajustar(frm)
    pag = Pagina.new('Actualizar existencias')
    form_edicion('Actualizar existencias', 'biecam.rb')
    id = frm['id']
    exi = Existencia.find(id)
    deposito_id = exi.deposito_id
    dep = Deposito.find(deposito_id)
    sucursal = dep.deposito
    puts pag.cgi.hidden('accion', 'act_exi') +
        pag.cgi.hidden('id', id) +
        pag.cgi.hidden('biecam_id', exi.biecam_id)
    puts frm.tr{frm.td{'Sucursal:'} + frm.td{sucursal}}
    input_numero('Cantidad:', 'cantidad', exi.cantidad)
    botones('biecam.rb?accion=listado')
    form_edicion_fin
    pag.fin
end
# Actualizacion de base de datos de existencias
def act_exi(frm)
  Existencia.find(frm['id'])
  Existencia.cantidad = frm['cantidad']
  Existencia.biecam_id = frm['biecam_id']
  Existencia.save
  pag = Pagina.new('Actualizando datos', 10)
  redirigir("biecam.prb?accion=ver&id=#{frm['biecam_id']}")
  pag.fin
end
# Transferir bienes entre sucursales: formulario
def transferir(frm)
    id = frm['id']
    depositos = Deposito.all
    pag = Pagina.new('Transferir bienes de cambio', 5)
    form_edicion('Transferencia', 'biecam.rb')
    puts pag.cgi.hidden('accion', 'acttra') +
        pag.cgi.hidden('id', id)
    input_combo('Tansferir hasta:', 'hasta', depositos, ['id', 'deposito'], '')
    input_numero('Cantidad a transferir:', 'cantidad', '')
    botones('biecam.rb?accion=listado')
    form_edicion_fin
    fin
end
# Efectuar transferencia de bienes
def acttra(frm)
    pag = Pagina("Transfiriendo bienes", 10)
    id = frm['id']
    cantidad_a_transferir = frm['cantidad']
    Existencia.find(id)
    origen = Existencia.deposito_id
    destino = frm['hasta']
    biecam_id = frm['biecam_id']
    pre_origen = Existencia.cantidad
    exist_destino = Existencia.find(:first, :conditions=>{
      :deposito_id=>destino,
      :biecam_id=>biecam_id})
    if exist_destino.count == 0
        Existencia.create(
            :deposito_id=>destino,
            :cantidad => cantidad_a_transferir,
            :biecam_id => biecam_id)
        saldo_origen = pre_origen - cantidad_a_transferir
        Existencia.find(id)
        Existencia.cantidad = saldo_origen
        Existencia.save
    else
        pre_destino = exist_destino.cantidad
        id_destino = exist_destino.id
        saldo_origen = pre_origen - cantidad_a_transferir
        saldo_destno = pre_destno + cantdad_a_transferir
        Existencia.find(id)
        Existencia.cantidad = saldo_origen
        Existencia.save
        Existencia.find(id_destino)
        Existencia.cantidad = saldo_destino
        Existencia.save
    end
    redirigir("biecam.rb?accion=ver&id=#{biecam_id}")
    pag.fin
end
if __FILE__ == $0
    form = CGI.new("html3")
    if form["accion"] == ""
        accion = "listado"
    else
        accion = form["accion"]
    end
    case accion
    when "nuevo"
        nuevo
    when "agregar"
        agregar(form)
    when "editar"
        editar(form)
    when "actualizar"
        actualizar(form)
    when "eliminar"
      bien = Bie_cam.find(form['id'])
      bien.delete
      listado
    when "ver"
        detalle(form)
    when "ajustar"
        ajustar(form)
    when "act_exi"
        act_exi(form)
    when "transferir"
        transferir(form)
    when "acttra"
        acttra(form)
    when "ingstock"
        ingstock(form)
    when "ingresar"
        ingresar(form)
    when "eliminar_existencia"
      pag = Pagina.new('Eliminando existencia', 10)
      exist = Existencia.find(form['id'])
      bien_id = exist.bie_cam_id
      exist.delete
      redirigir("biecam.rb?accion=ver&id=#{bien_id}")
      pag.fin
    else
        listado
    end
end
