#!/usr/bin/env ruby
# Programa para conciliaciones de transacciones
require 'cgi_exception'
require 'cgi'
require 'datos'
require 'htm'
require 'funciones'
require 'csv'
# Crear la tabla borrando la previa si existe
def nueva(frm)
    pag = Pagina.new("Llenar tabla de conciliacion", 4)
    puts "Llenar una nueva tabla de conciliación implica perder la anterior."
    boton("Volver", "geined.py?accion=contabilidad")
    cuentas_combo = Cuenta.find_by_sql('SELECT id,CONCAT(rubro,"-",nombre) as selec FROM cuentas')
    formulario("conciliacion.rb")
    puts pag.cgi.hidden('accion', 'llenar')
    input_combo('Cuenta:', 'cuenta_id', cuentas_combo, ['id', 'selec'], 'Seleccionar...')
    puts pag.cgi.td{pag.cgi.submit('Llenar')}
    fin_formulario
end
# Llenar con datos de un rubro en particular
def llenar(frm)
    Conciliacion.delete_all
    transacciones = Transaccion.find(:all,
        :conditions=>{:cuenta_id=>frm['cuenta_id']})
    transacciones.each do |fila|
        Conciliacion.create(
            :id_id => fila.id,
            :fecha => fila.fecha,
            :detalle => fila.detalle,
            :cuenta_id => fila.cuenta_id,
            :debe => fila.debe,
            :haber => fila.haber)
    end
end
# Desplegar listado
def listado(frm)
    pag = Pagina.new("Conciliación de cuentas", 4)
    cuenta_id = frm['cuenta_id']
    cuenta = Cuenta.find(cuenta_id)
    puts pag.cgi.h2{"Conciliación de: #{cuenta.rubro} - #{cuenta.nombre}"}
    filas_por_pagina = 20
    if frm.has_key?('pagina')
        pagina_actual = frm['pagina']
    else
        pagina_actual = 1
    end
    off_set = (pagina_actual.to_i - 1) * filas_por_pagina
    tot_debe = Conciliacion.sum(:debe)
    tot_haber = Conciliacion.sum(:haber)
    tot_saldo = tot_haber - tot_debe
    puts pag.cgi.table{
        pag.cgi.tr{
            pag.cgi.th{'Debe'} +
            pag.cgi.th{'Haber'} +
            pag.cgi.th{'Saldo'}
        } +
        pag.cgi.tr{
            pag.cgi.td('align'=>'right'){moneda(tot_debe)} +
            pag.cgi.td('align'=>'right'){moneda(tot_haber)} +
            pag.cgi.td('align'=>'right'){moneda(tot_saldo)}
        }
    }
    total_filas = Conciliacion.find(:all).size
    total_paginas = total_filas / filas_por_pagina
    off_set = (pagina_actual.to_i - 1) * filas_por_pagina
    boton('Volver', 'geined.py?accion=contabilidad')
    if frm.has_key?('mostrar')
        if frm['mostrar'] == 'no'
            mostrar='no'
            boton('Mostrar', "conciliacion.rb?accion=listado&cuenta_id=#{cuenta_id}&mostrar=si")
            total_filas = Conciliacion.find(:all, :conditions=>{:check=>nil}).size
            conciliacion = Conciliacion.find(:all,
                :conditions=>{:check=>nil},
                :limit=>filas_por_pagina,
                :offset=>off_set,
                :order=>:fecha)
        else
            mostrar='si'
            boton('Ocultar', "conciliacion.rb?accion=listado&cuenta_id=#{cuenta_id}&mostrar=no")
            total_filas = Conciliacion.find(:all).size
            conciliacion = Conciliacion.find(:all,
                :limit=>filas_por_pagina,
                :offset=>off_set,
                :order=>:fecha)
        end
    else
        mostrar='no'
        boton('Mostrar', "conciliacion.rb?accion=listado&cuenta_id=#{cuenta_id}&mostrar=no")
        total_filas = Conciliacion.find(:all, :conditions=>{:check=>nil}).size
        conciliacion = Conciliacion.find(:all,
            :conditions=>{:check=>nil},
            :limit=>filas_por_pagina,
            :offset=>off_set,
            :order=>:fecha)
    end
    boton('Nueva tabla', "conciliacion.rb?accion=nueva&cuenta_id=#{cuenta_id}")
    boton('Exportar a planilla',
        "conciliacion.rb?accion=exportar&cuenta_id=#{cuenta_id}&mostrar=#{mostrar}")
    formulario('conciliacion.rb')
    puts pag.cgi.hidden('accion', 'actualizar')
    puts pag.cgi.hidden('mostrar', mostrar)
    puts pag.cgi.hidden('pagina', pagina_actual.to_s)
    puts pag.cgi.hidden('cuenta_id', cuenta_id)
    total_paginas = total_filas / filas_por_pagina
    off_set = (pagina_actual.to_i - 1) * filas_por_pagina

    i = 0
    saldo = 0
    encabezado_tabla(['Nº', 'Fecha', 'Detalle', 'Debe', 'Haber', 'Marca', 'Saldo'])
    conciliacion.each do |fila|
        fila_alterna(i)
        celda(fila.id_id)
        celda(mysql_a_fecha(fila.fecha))
        celda(fila.detalle)
        linea_moneda(fila.debe)
        linea_moneda(fila.haber)
        saldo = saldo + fila.debe - fila.haber
        adicional = ""
        if fila.check
            adicional = "checked"
        end
        celda("<input type='checkbox' name='check_#{i}' value='1' #{adicional}>")
        print pag.cgi.hidden("campo_#{i}", fila.id.to_s)
        linea_moneda(saldo)
        puts '</tr>'
        i = i + 1
    end
    fin_tabla
    puts pag.cgi.submit('Actualizar')
    fin_formulario
    navegador("conciliacion.rb?accion=listado&cuenta_id=#{cuenta_id}&mostrar=#{mostrar}", pagina_actual, total_paginas,union='&')
    boton('Volver', 'geined.py?accion=contabilidad')
end
def actualizar(frm)
    for i in 0..19
        ident = frm["campo_#{i}"]
        check_valor = frm["check_#{i}"]
        if ident.to_i > 0
            Conciliacion.update(ident,
                :check=>check_valor)
        end
    end
end
def exportar(frm)
    archivo = StringIO.new
    cuenta_id = frm['cuenta_id']
    cuenta = Cuenta.find(cuenta_id)
    nom_archivo = "Conciliacion_#{cuenta.rubro}.csv"
    if frm.has_key?('mostrar')
        if frm['mostrar'] == 'no'
            mostrar='no'
            conciliacion = Conciliacion.find(:all,
                :conditions=>{:check=>nil},
                :order=>:fecha)
        else
            mostrar='si'
            conciliacion = Conciliacion.find(:all,
                :order=>:fecha)
        end
    else
        mostrar='no'
        conciliacion = Conciliacion.find(:all,
            :conditions=>{:check=>nil},
            :order=>:fecha)
    end
    saldo = 0
    sum_debe =0
    sum_haber = 0
    CSV::Writer.generate(archivo) do |conc_csv|
        conc_csv <<(["Nº", "Fecha", "Detalle", "Debe", "Haber", "Saldo"])
        conciliacion.each do |fila|
            saldo = saldo +  fila.haber - fila.debe
            sum_debe = sum_debe + fila.debe
            sum_haber = sum_haber + fila.haber
            conc_csv << [fila.id,
                mysql_a_fecha(fila.fecha),
                fila.detalle,
                fila.debe.to_s.gsub(".",","),
                fila.haber.to_s.gsub(".",","),
                saldo.to_s.gsub(".",",")]
        end
        conc_csv << ["","","Total",
            sum_debe.to_s.gsub(".",","),
            sum_haber.to_s.gsub(".",","),
            saldo.to_s.gsub(".",",")]
    end
    archivo.rewind
    puts "Content-Type: text/csv"
    puts "Content-Disposition: attachment; filename=\"#{nom_archivo}\""
    puts ""
    archivo.each do |fila|
        puts fila
    end
end

if __FILE__ == $0
    form = CGI.new('html4')
    accion = 'listado'
    if form.has_key?('accion')
        accion = form['accion']
    end
    case accion
    when 'listado'
        if form.has_key?('cuenta_id')
            listado(form)
        else
            if Conciliacion.find(:all).size ==0
                nueva(form)
            else
                conciliacion = Conciliacion.find(:first)
                cta = conciliacion.cuenta_id.to_s
                form.params['cuenta_id'] = [cta]
                listado(form)
            end
        end
    when 'actualizar'
        actualizar(form)
        listado(form)
    when 'llenar'
        llenar(form)
        listado(form)
    when 'nueva'
        nueva(form)
    when 'exportar'
        exportar(form)
    else
        listado(form)
    end
end
