#!/usr/bin/env ruby
require 'cgi_exception'
require 'funciones'
require 'datos'
require 'htm'
# Listado de cuenta corriente de cliente. Entrada: id
def listado(frm, ti='comun')
  # Contemplar qué pasa si no hay cliente_id
  unless frm.has_key?('id')
    error_variable('cli.py')
  else
    cliente_id = frm['id']
    cliente = Cliente.find(cliente_id)
    pag = Pagina.new('Estado de cuenta del cliente', nivel=5, fecha=0, tipo=ti)
    puts pag.cgi.h2{cliente.nombre} +
      pag.cgi.h3{cliente.direccion} +
      pag.cgi.h4{cliente.telefono}
    boton('Nuevo', "ctacli.rb?accion=nuevo&id=#{cliente_id}")
    boton('Imprimir', "ctacli.rb?accion=imprimir&id=#{cliente_id}")
    # cargar datos
    cta_clientes = Cta_cliente.find(:all, :conditions=>{:cliente_id=>cliente_id}, :order=>:fecha)
    encabezado_tabla(["Nº", "Fecha", "Concepto", "Debe", "Haber"])
    i = 0
    cta_clientes.each do |fila|
      fila_alterna(i)
      celda(fila.id)
      #celda(mysql_a_fecha(fila.fecha))
      celda(mysql_a_fecha(fila.fecha))
      celda(fila.concepto)
      linea_moneda(fila.debe)
      linea_moneda(fila.haber)
      puts '</tr>'
      i = i + 1
    end
    #saldos = Cta_cliente.find_by_sql("SELECT SUM(debe) as d, SUM(haber) as h FROM cta_clientes WHERE  cliente_id=#{cliente_id}")
    debe = Cta_cliente.sum(:debe, :conditions=>{:cliente_id=>cliente_id})
    haber = Cta_cliente.sum(:haber, :conditions=>{:cliente_id=>cliente_id})
    #debe = saldos.d
    #haber= saldos.h
    saldo = haber - debe
    puts pag.cgi.tr{
      pag.cgi.td{} + pag.cgi.td{} + pag.cgi.td{'Subtotales'} +
      pag.cgi.td("align"=>"right"){moneda(debe)} +
      pag.cgi.td("align"=>"right"){moneda(haber)}
    } +
    pag.cgi.tr{
      pag.cgi.td{} + pag.cgi.td{} + pag.cgi.td{"Saldo"} + pag.cgi.td{} +
      pag.cgi.td("align"=>"right"){moneda(saldo)}

    }
    puts '</tbody></table>'
    boton('Volver', "cli_ver.php?id=#{frm['id']}")
    pag.fin
  end
end
def actualizar(frm)
    id = form['id']
    cta_clientes = Cta_Cliente.find(id)
    cta_clientes.concepto = frm['concepto']
    cta_clientes.debe = frm['debe']
    cta_clientes.haber = frm['haber']
    cta_clientes.save
    listado
end
def nuevo(frm)
    pag = Pagina.new('Nueva entrada a la cuenta del cliente', nivel=5, fecha=1)
    cliente_id = frm['cliente_id']
    form_edicion('Nuevo item cuenta cliente', 'ctacli.rb')
    puts pag.cgi.hidden('accion', 'agregar') +
        pag.cgi.hidden('cliente_id', cliente_id)
    input_fecha('Fecha:', 'fecha', fecha_a_mysql(hoy))
    input_texto('Concepto:', 'concepto', '')
    input_numero('Debe:', 'debe', '')
    input_numero('Haber', 'haber', '')
    botones("ctacli.rb?accion=listado&id=#{cliente_id}")
    pag.fin
end
def agregar(frm)
  fecha = Fecha.new(frm['fecha'], 'eu')
    Cta_cliente.create({
        :fecha => fecha.us,
        :cliente_id => frm['cliente_id'],
        :concepto => frm['concepto'],
        :debe => frm['debe'],
        :haber => frm['haber']})
    listado(frm)
end

if __FILE__ == $0
    form = CGI.new('html3')
    accion = 'listado'
    if form.has_key?('accion')
        accion = form['accion']
    end
    case accion
    when 'listado'
        listado(form)
    when 'editar'
        editar
    when 'actualizar'
        actualizar(form)
    when 'nuevo'
        nuevo(form)
    when 'agregar'
        agregar(form)
    when 'confirmar'
        confirmar_borrar(form['id'])
        boton('Volver al listado', 'ccl.py?accion=listado')
    when 'eliminar'
        autorizacion(2)
        borrar('cta_clientes', form['id'], 'ccl.py?accion=listado')
    when 'imprimir'
        listado(form, tipo='informe')
    end
end
