#!/usr/bin/env python
# -*- coding: utf-8 -*-
"""Funciones generales """
import datetime
def moneda(num):
    """transforma un número en una cadena con formato moneda"""
    mon = numero(num, 2)
    mon = '$' + mon
    return mon
def substr_replace(cadena, reemplazo, posicion):
    """Reemplaza CADENA con REEMPLAZO en POSICION, sin alterar la longitud de la cadena"""
    s = cadena[:posicion] + reemplazo + cadena[posicion + len(reemplazo):]
    return s
def mysql_a_fecha(fecha):
    """Convierte fecha en formato mysql a legible"""
    if type(fecha) == type(None):
        return ""
    if (type(fecha) is (datetime.date) or (type(fecha) is datetime.datetime)):
        ano = str(fecha.year)
        mes = str(fecha.month)
        if len(mes)==1:
            mes = "0" + mes
        dia = str(fecha.day)
        if len(dia)==1:
            dia = "0" + dia
    else:
        ano = fecha[0:4]
        mes = fecha[5:7]
        dia = fecha[8:11]
    fecha2 = dia + "/" + mes + "/" + ano
    return fecha2
def fecha_a_mysql(fecha):
    """Convierte fecha legible a fecha aceptable por mysql"""
    fec = fecha.split("/")
    dia = fec[0]
    mes = fec[1]
    ano = fec[2]
    if len(ano) == 2:
        if int(ano) < 40:
            ano = "20" + ano
        else:
            ano = "19" + ano
    fecha2 = ano + "-" + mes + "-" + dia
    return fecha2
def numero_version2(num, places=0):
    """Format a number with grouped thousands and given decimal places"""
    #is_negative = (num < 0)
    #if is_negative:
    # num = -num
    places = max(0, places)
    tmp = "%.*f" % (places, num)
    point = tmp.find(".")
    integer = (point == -1) and tmp or tmp[:point]
    decimal = (point != -1) and tmp[point:] or ""
    count = 0
    # commas = 0 - creo que es innecesario
    formatted = []
    for i in range(len(integer) - 1, 0, -1):
        count += 1
        formatted.append(integer[i])
        if count % 3 == 0:
            formatted.append(",")
            formatted.append(integer[0]) # this misses in your part
    integer = "".join(formatted[::-1])
    return integer + decimal
def numero(num, places=0):
    """Format a number with grouped thousands and given decimal places"""
    if type(num) is str:
        num = float(num)
    if type(num) == type(None):
        num = 0
    places = max(0, places)
    tmp = "%.*f" % (places, num)
    point = tmp.find(".")
    integer = (point == -1) and tmp or tmp[:point]
    decimal = (point != -1) and tmp[point:] or ""
    count =  0
    formatted = []
    for i in range(len(integer), 0, -1):
        count += 1
        formatted.append(integer[i - 1])
        if count % 3 == 0 and i - 1:
            formatted.append(",")
    integer = "".join(formatted[::-1])
    return integer+decimal
def hoy():
    """Devuelve el día de hoy en formato estándard"""
    return datetime.date.today().strftime("%d/%m/%y")
if __name__ == 'main':
    print "Es un módulo no ejecutable"
