#!/usr/bin/env ruby
# Conjunto de rutinas para generar paginas htm
#require "os"
require 'funciones'
require 'cgi'
# Clase para generar una pagina web
class Pagina
    attr_accessor :cgi
    def initialize(titulo, nivel=20, fecha=0, tipo='comun')
        #tipos: comun, boleta, informe
        @cgi = CGI.new("html3")
        @tipo = tipo
        @fecha = fecha
        inicio
        autorizacion(nivel)
        @titulo = titulo
        encabezado(@titulo)
        @filas_por_pagina = 20
    end
    # Agrega cadena que hace referencia a archivo css
    def estilo
        case @tipo
        when "boleta"
            enlace = "./css/boleta.css"
        when "informe"
            enlace = "./css/greyscale.css"
        else
            enlace = "./css/geinedpy.css"
        end
        puts "<link type='text/css' href='#{enlace}' rel='stylesheet' />"
    end
    #"""Encabezado de pagina web"""
    def encabezado(titulo)
        #inicio
        puts "<head>"
        puts "<script type='text/javascript' src='geined.js' charset='utf-8'></script>"
        if @tipo == "boleta"
            puts @cgi.title{"Boleta"}
        else
            puts @cgi.title{titulo}
        end
        estilo
        if @fecha >= 1
            puts '<style type="text/css">@import url(./js/calendar-win2k-1.css);</style>'
            puts '<script type="text/javascript" src="./js/calendar.js"></script>'
            puts '<script type="text/javascript" src="./js/lang/calendar-es.js"></script>'
            puts '<script type="text/javascript" src="./js/calendar-setup.js"></script>'
        end
        puts "</head><body>"
        if @tipo == "comun"
            puts "<table class='tmenu'><tr>"
            puts @cgi.td{"<img src='./conf/logo.png' />"}
        end
        deposito = @cgi.cookies["deposito_id"][0]
        if deposito == nil then deposito = 0 end
        case deposito.to_s
            when '0' then sucursal = "Sin asignar"
            when '1' then sucursal = "Central"
            when '2' then sucursal = "Costa de Oro"
            when '3' then sucursal = "Carrasco"
            else
                sucursal = "xxxx"
        end
        if @tipo == "comun"
            puts @cgi.td("align"=>"right"){
                @cgi.a("title"=>"Inicio", "href"=>"geined.py"){
                    @cgi.img("./img/inicio.png", "Inicio")
                } +
                @cgi.a("title"=>"Reportar un error", "href"=>"des.py"){
                    @cgi.img("./img/idea.png", "Error")
                } +
                @cgi.a("title"=>"Cambiar de sucursal", "href"=>"suc.php"){
                    @cgi.img("./img/cambiar.png", "Sucursal")
                }
            }
            puts "</tr></table>"
            puts @cgi.table("class"=>"tmenu2"){
                @cgi.tr{
                    @cgi.td('align'=>'left'){titulo} +
                    @cgi.td('align'=>'right'){"#{@cgi.cookies['usuario'][0]} en #{sucursal}"}
                }
            }
        end
    end
    # Tags de finalizacion de una pagina
    def fin
        if @fecha >= 1 then script_fecha end
        if @fecha >= 2 then script_fecha2 end
        puts "</body></html>"
    end
    # Rutina para autorizar ingreso a una pagina
    def autorizacion(niv)
        # 20: cualquiera 10: docente 5: recepcion 4: Adriana
        # 3: Hassan / Leo 2: Mariana 1: Marcelo
        nivel = @cgi.cookies["nivel"][0]
        if nivel == nil
            redirigir("Login.php")
        else
            if nivel.to_i > niv then redirigir("no_autorizado.html") end
        end
    end
    # Entrada de fecha en campo texto con boton que despliega calendario
    def entrada_fecha(texto, campo, valor)
        # diferenciar segun tipo de valor
        if valor.class == Date
            fecha = valor
        elsif valor.class == String
            s = separador(valor)
        end
        @cgi.tr{
            @cgi.td{@cgi.label("for"=>campo){texto}} +
            @cgi.td{
                @cgi.text_field(campo, fecha.eu, 40, nil, 'id'=>'f_date_b') +
                @cgi.button('type'=>'reset', 'id'=>'f_trigger_b'){'...'}
            }
        }
    end
    def entrada_fecha_2(texto, campo, valor)
        puts @cgi.tr{
            @cgi.td{@cgi.label('for'=>campo){texto}} +
            @cgi.td{
                @cgi.text_field(campo, fecha.eu, 40, nil,  'id'=>'f_date_b2') +
                @cgi.button('type'=>'reset', 'id'=>'f_trigger_b2'){'...'}
            }
        }
    end

end
# Lee una cookie presente en la sesion"""
def leer_cookie
    coo = Cookie.SimpleCookie(os.environ.get("HTTP_COOKIE",""))
    return coo
end
def encabezado(titulo)
    """Encabezado de pagina web"""
    inicio
    puts '<head>'
    puts '<script type="text/javascript" src="geined.js" charset="utf-8"></script>'
    title(titulo)
    estilo()
    print '</head><body><div id="envoltura">'
    print "<table><tr>"
    celda("img src='./conf/logo.png' />")
    celda("<h1>"+titulo+"</h1>")
    # print "</tr>"
    sesion = leer_cookie()
    if not sesion.has_key?("deposito_id")
        sucursal = "Sin asignar"
        deposito_id = 0
    else
        deposito_id = int(sesion['deposito_id'].value)
    end
    if deposito_id == 1
        sucursal = "Central"
    elsif deposito_id == 2
        sucursal = "Costa de Oro"
    elsif deposito_id == 3
        sucursal = "Carrasco"
    else
        sucursal = "xxxx"
    end
    celda("Usted se encuentra en: " + sucursal)
    #print "<tr><td>Usted se encuentra en: " + sucursal  +"</td><td>"
    print("<td>")
    a("geined.py", "Inicio")
    print ' | '
    a("des.py", "Reportar error")
    print ' | '
    a("suc.py", "Cambiar de sucursal")
    print "</td></tr></table>"
end
# Tags de finalizacion de una pagina
# Imprime encabezado de pagina web SIN cookie
def inicio
    puts 'Content-Type: text/html; charset=utf-8'
    puts ''
end
def encabezado_informe(titulo)
    """Imprime un encabezado, pero haciendo referencia a una hoja de estilo para informes"""
    inicio()
    title(titulo)
    estilo("greyscale.css")
    print '</head><body>'
    h1(titulo)
end
def encabezado_recibo(titulo)
    """Encabezado para recibo de sueldos"""
    inicio()
    title(titulo)
    estilo("recibo.css")
    print('</head><body>')
    h1(titulo)
end
# Imprime una tabla con texto pequeno"""
def nota(texto)
    puts "<table width=\"100%\"><tr><td><span class=\"nota\">#{texto}</span></td></tr></table>"
end
# Imprime boton de enviar formulario con texto = Aceptar
def botones(url)
  puts '<tr><table class="tform">'
  puts '<tr>'
  puts '<td align="center"><input type="submit" value="Aceptar" style="height: 40px; width:
150px"></td>'
  puts "<td align='center'><input type='button' value='Cancelar' style='height: 40px; width: 150px'
onClick=parent.location='#{url}' /></td>"
   puts '</tr></table></tr>'
  #puts "<p><input type='submit' value='Aceptar'><input type='button' value='Cancelar'
#sonClik=parent.location='#{url}' /></p>"
end
# Imprime una celda con el TEXTO especificado
def celda(texto, alineado="i")
    texto = texto.to_s
    if alineado == "d" or alineado == "derecha"
        puts "<TD align='right'>#{texto}</TD>"
    else
        puts "<TD>#{texto}</TD>"
    end
end
# Imprime una hilera con 2 celdas: una de texto y otra de datos
def fila_datos(texto, datos)
    print '<tr>'
    celda(texto)
    datos = datos.to_s
    celda(datos)
    print '</tr>'
end
# Imprime una celda con un valor monetario adentro
def linea_moneda(texto)
    celda(moneda(texto), "derecha")
end
def linea_numero(texto, decimales=2)
    """Imprime una celda con un número formateado con 2 decimales"""
    celda(funciones.numero(texto, decimales, '.', ''), "derecha")
end
# Pone pagina de acceso no autorizado
def no_autorizado(retorno)
    pag = Pagina.new("Acceso no autorizado", 20)
    nota('Usted no se encuentra autorizado para ver esta página')
    boton('Volver', retorno)
    pag.fin
end
# Impide que funcione la tecla enter en una pagina
def script_noenter
    print "<script type='text/javascript'>"
    print "function stopRKey(evt) {"
    print "var evt = (evt) ? evt : ((event) ? event : null);"
    print "var node = (evt.target) ? evt.target : ((evt.srcElement) ? evt.srcElement : null);"
    print "if ((evt.keyCode == 13) && (node.type=='text'))  {return false;}"
    print "}"
    print "document.onkeypress = stopRKey;"
    puts "</script>';"
end
# Linea con celda con texto y otra con combobox
def input_combo(texto, campo, resultado, campos, valor)
    puts '<tr>'
    celda "<label for='#{campo}'>#{texto}</label>"
    puts "<td><select name='#{campo}' id='#{campo}'>"
    resultado.each do |fila|
        print "<option value='#{fila[campos[0]].to_s}'"
        if fila[campos[0]].to_s == valor.to_s
            print "selected='selected'"
        end
        print ">#{fila[campos[1]]}</option>"
    end
    puts '</select></td></tr>'
end
# Crea celdas contiguas con texto y campo de texto
def input_fecha(texto, campo, valor)
    # diferenciar segun tipo de valor
    if valor.class == Date
        fecha = valor
    elsif valor.class == String
        s = separador(valor)
    end
    print '<tr>'
    # @TODO: verificar que fecha ingresada este en el formato correcto
    # posibilidad de usar objeto DATE o usar objeto FECHA creado en funciones
    celda "<label for='#{campo}'>#{texto}:</label>"
    print "<td><input type='text' name='#{campo}' id='f_date_b' value='#{mysql_a_fecha(valor)}'>"
    puts '<button type="reset" ID="f_trigger_b">...</button></td>'
    puts '</tr>'
end
# Crea celdas para form con 2 fechas
def input_fecha2(texto, campo, valor)
    print '<tr>'
    celda "<label for='#{campo}'>#{texto}:</label>"
    print "<td><input type='text' name='#{campo}' id='f_date_b2' value='#{mysql_a_fecha(valor)}'>"
    puts '<button type="reset" ID="f_trigger_b2">...</button></td>'
    puts '</tr>'
end
# Imprime una linea de formulario con entrada de texto
def input_texto(texto, campo, valor='', ancho=60)
    print '<tr>'
    celda "<label for='#{campo}'>#{texto}:</label>"
    celda "<input type='text' name='#{campo}' value='#{valor}' size='#{ancho}'/>"
    puts '</tr>'
end
def input_disabled(texto,campo,valor,ancho=60)
    """Imprime celda con texto y texto, muestra un campo no modificable"""
    print("<tr>")
    celda(texto)
    print "<td><input disabled type='text' "
    print "name='#{campo}' value='#{valor}' size='#{ancho}'/></td></tr>"
end
# Imprime 2 celdas adyacentes en 1 fila ambas con texto
def input_label(texto1, texto2)
  puts '<tr>'
  celda "<label for='#{texto1}'>#{texto1}</label>"
  # puts "<input type='text' disabled value='#{texto2}'></p>"
  celda texto2
  puts '</tr>'
end
# Imprime un campo de ingreso de valor numerico
def input_numero(texto, campo, valor=0, decimales=2)
    tex = texto.to_s
    if valor.class == String
        if valor == ""
            valor = "0"
        end
    end
    puts '<tr>'
    celda "<label for='#{campo}'>#{texto}</label>"
    celda "<input type=\"text\" style=\"text-align:right\" name=\"#{campo}\"
value=\"#{valor}\">"
  puts '</tr>'
    #{numero(valor, decimales)}
end
# Imprime una linea con una celda con texto y otra con un campo memo
def input_memo(texto, campo, valor)
    if valor.class == NilClass
        valor = ""
    end
    puts '<tr>'
    celda(texto)
    puts "<td><textarea name='#{campo}' rows=\"10\" cols=\"50\">#{valor}</textarea></td></tr>"
end
# Imprime el encabezado de un formulario
def formulario(accion, alineado="")
    if alineado == "centrado"
        print "<div align='center'><form action='#{accion}' method='POST'>"
    else
        print "<div><form action='#{accion}' method='POST'>"
    end
end
#Imprime un formulario de edición
def form_edicion(texto, accion)
    puts "<div align='center'><form action='#{accion}' method='post'>"
    puts "<table class='tform'><caption>#{texto}</caption>"
end
# Finaliza un formulario de edición
def form_edicion_fin
    puts '</table></form></div>'
end
# Imprime tags de finalizacion de una tabla
def fin_tabla
    puts '</tbody></table>'
end
# Pone un boton
def boton(texto, accion)
    puts "<input type=\"button\" value=\"#{texto}\" onClick=parent.location=\"#{accion}\" />"
end
# Pone una imagen de eliminar cliqueable
def boton_detalles(accion)
    puts "<a href='#{accion}' title='Detalles'><img src='./img/ver.png' width='24' height='24' border='0'></a>"
end
# Pone una imagen de eliminar cliqueable
def boton_editar(accion)
    print "<a href='#{accion}' title='Editar'>"
    print "<img src='./img/editar.png' width='24' height='24' border='0'>"
    puts "</a>"
end
# Pone una imagen de imprimir cliqueable
def boton_imprimir(accion)
    print "<a href='#{accion}' title='Editar'>"
    print "<img src='./img/printer32.png' width='24' height='24' border='0'>"
    puts "</a>"
end
# Pone una imagen de eliminar cliqueable, saca diálogo para confirmar
def boton_eliminar(accion)
    print "<a href='#' title='Eliminar registro'>"
    print "<img src='./img/eliminar.png' width='24' height='24' border='0'
onClick=\"if(confirm('¿Desea borrar este registro?')) window.location='#{accion}';\">"
    puts "</a>"
end
# pone un boton con un TEXTO que saca diálogo para confirmar
def boton_confirmar(texto, leyenda, accion)
    puts "<input type='button' value='#{texto}' onClick=\"if(confirm('#{leyenda}'))
window.location='#{accion}';\">"
end
# Pone imagen con caracteristicas predeterminadas
def imagen(img)
    puts "<img src=\"./img/#{img}\" width=\"64\" height=\"64\" border=\"0\">"
end
def encabezado_tabla(arr)
    """A partir de un array arma el encabezado de una tabla"""
    #print '<table width="100%"><thead><tr>'
    print('<table><thead><tr>')
    for lin in arr
        th(lin)
    end
    print '</tr></thead><tbody>'
end
# Termina el formulario
def fin_formulario
    print '</form></div>'
end
def input_input(tipo, nombre, valor='')
    """Imprime un campo tipo INPUT"""
    print('<input type="'+ tipo + '" name="' + nombre + '" value="'+ valor + '"></input>')
end
def input_check(texto, variable, valor)
    """Imprime 2 celdas, una con texto y otra con un checkbox"""
    print '<TR><TD>'
    print texto
    adicional = ""
    if valor == "1"
        adicional = "checked"
    end
    print "</TD><TD><INPUT TYPE='checkbox' "
    puts "NAME='#{variable}' VALUE='1' #{adicional}></TD></TR>"
end
# Linea horizontal
def linea
    print '<hr />'
end
# Genera colores alternos para filas de una tabla
def fila_alterna(i)
    if (i % 2) == 0
        print "<tr onMouseOver='this.className=\"highlight\"' onMouseOut='this.className=\"normal\"'>"
    else
        print "<tr class='odd' onMouseOver='this.className=\"highlight\"' onMouseOut='this.className=\"odd\"'>"
    end
end
# Imprime una celda con una imagen, enlace y texto
def imagen_menu(img, enlace, texto)
    print '<td align="center"><a href="' + enlace + '"><img src="./img/' +\
    img  + '" width="64" height="64" align="top" border="0"></a>' + \
    texto + '</td>'
end
# Genera html de error por existencia de duplicado
def duplicado(pag)
    texto = 'Ya existe un dato igual al que usted intenta agregar.'
    texto = texto + ' Verifique el dato e inténtelo nuevamente'
    nota(texto)
    boton('Volver', pag)
end
# Devuelve una página con el error
def error_variable(retorno)
    pag = Pagina.new('Error de variables', 20)
    puts 'Faltan variables para realizar la operacion<br />'
    boton('Volver', retorno)
    pag.fin
end
# Imprime un navegador al pie de una tabla
def navegador(este_archivo, pagina_actual, total_paginas, union='?')
    nav = ''
    unless pagina_actual.class == Fixnum
        pagina_actual = pagina_actual.to_i
    end
    unless total_paginas.class == Fixnum
        total_paginas = total_paginas.to_i
    end
    for n in 1..(total_paginas + 1)
        if n == pagina_actual
            nav = "#{nav} #{pagina_actual.to_s} "
        else
            nav = "#{nav} <a href='#{este_archivo}#{union}pagina=#{n.to_s}'>#{n.to_s}</a> "
        end
    end
    #enlaces a primero - anterior - posterior - ultimo
    if pagina_actual > 1
        pag = pagina_actual -1
        prev = " <a href='#{este_archivo}?pagina=#{pag.to_s}'>[<-]</a> "
        prim = " <a href='#{este_archivo}?pagina=1'>[<<]</a> "
    else
        prev = " "
        prim = " "
    end
    if pagina_actual < total_paginas
        pag = pagina_actual + 1
        sig = " <a href='#{este_archivo}?pagina=#{pag.to_s}'>[->]</a> "
        ult = " <a href='#{este_archivo}?pagina=#{(total_paginas + 1).to_s}'>[>>]</a> "
    else
        sig = " "
        ult = " "
    end
    print("<hr />")
    print("<center>" + prim + prev + nav + sig + ult + "</center>")
    print("<hr />")
end
# Redirige usando javascript a otra pagina
def redirigir(url)
    texto = 'window.location = "' + url + '";'
    script(texto, "text/javascript")
end
# Imprime en una pagina web un javascript para manejo de fechas
def script_fecha
    texto = "Calendar.setup({
        inputField     :    'f_date_b',     //*
        ifFormat       :    '%d/%m/%Y',
        showsTime      :    false,
        button         :    'f_trigger_b',  //*
        step           :    1
        });"
    script(texto, "text/javascript")
end
def script_fecha2
    texto2 = "Calendar.setup({
        inputField     :    'f_date_b2',
        ifFormat       :    '%d/%m/%Y',
        showsTime      :    false,
        button         :    'f_trigger_b2',
        step           :    1
        });"
    script(texto2, "text/javascript")
end
# Tag html
def script(texto, typ='', src='')
    if typ != ''
        typ = "type='#{typ.to_s}'"
    end
    if src != ''
        src = "src='#{src.to_s}'"
    end
    puts "<script #{typ} #{src}>#{texto.to_s}</script>"
end
# Tag html
def th(texto)
    puts "<th>#{texto.to_s}</th>"
end
# Devuelve página con error en parámetros
def error_parametros(retorno)
    pag = Pagina.new("Error de parámetros", 20)
    puts "Hay un error en los parámetros pasados<br />"
    boton("Volver", retorno)
    pag.fin
end
if __FILE__ == $0
    puts "Es un módulo no ejecutable"
end
