#!/usr/bin/env ruby
require "cgi"
require "cgi_exception"
require "htm"
require "datos"
require 'funciones'
def listado(frm)
    pag = Pagina.new("Listado de inventario")
    boton('Nuevo', 'inventario.rb?accion=nuevo')
    boton('Volver', 'geined.py?accion=administracion')
    inventario = Inventario.find(:all)
    encabezado_tabla(['No.', 'Nombre', 'Deposito', 'Compra', 'Costo', 'Vida', 'Residual', 'Metodo', 'Valor', 'Fecha', 'Acciones'])
    i = 0
    inventario.each do |fila|
        fila_alterna(i)
        celda(fila.id)
        celda(fila.nombre)
        deposito = Deposito.find(fila.deposito_id)
        celda(deposito.deposito)
        fecha_compra = Fecha.new(fila.compra, 'mysql')
        celda(fecha_compra.eu)
        celda(moneda(fila.costo))
        celda(fila.vida)
        celda(moneda(fila.residual))
        celda(fila.metodo)
        celda(moneda(fila.revaluacion))
        fecha_rev = Fecha.new(fila.fecha_rev, 'mysql')
        celda(fecha_rev.eu)
        print '<td>'
        boton('Editar', "inventario.rb?accion=editar&id=#{fila.id}")
        boton('Eliminar',  "inventario.rb?accion=eliminar&id=#{fila.id}")
        boton("Recalcular", "inventario.rb?accion=recalcular&id=#{fila.id}")
        puts '</td></tr>'
        i = i + 1
    end
    pag.fin
end
def nuevo(frm)
    depositos = Deposito.find(:all)
    pag = Pagina.new("Nuevo item de inventario", nivel=4, fecha=2)
    form_edicion("Nuevo item", 'inventario.rb')
    puts pag.cgi.hidden("accion", "agregar")
    input_texto("Nombre:", 'nombre')
    input_combo("Deposito:", "deposito_id", depositos, ['id', 'deposito'], '')
    fecha_compra = Fecha.new(hoy)
    input_fecha("Fecha de compra:", 'compra', fecha_compra_mysql)
    input_numero("Costo:", 'costo')
    input_numero('Vida útil:', 'vida')
    input_numero('Valor residual', 'residual')
    input_texto('Método de cálculo:', 'metodo')
    input_numero('Revaluación:', 'revaluacion')
    input_fecha2('Fecha de revaluación:', 'fecha_rev', fecha_a_mysql(hoy))
    botones('inventario.rb?accion=listado')
    form_edicion_fin
    pag.fin
end
# Agregar item a inventario, con fecha corregida
def agregar(frm)
    compra = Fecha.new(frm['compra'], 'eu')
    fecha_rev = Fecha.new(frm['fecha_rev'], 'eu')
    Inventario.create(
        :nombre => frm['nombre'], 
        :deposito_id => frm['deposito_id'], 
        :compra => compra.us, 
        :costo => frm['costo'], 
        :vida => frm['vida'], 
        :residual => frm['residual'], 
        :metodo => frm['metodo'], 
        :revaluacion => frm['revaluacion'], 
        :fecha_rev => fecha_rev.us)
    listado(frm)
end
def editar(frm)
    inventario = Inventario.find(frm['id'])
    depositos = Deposito.find(:all)
    pag = Pagina.new("Editando item de inventario", nivel=4, fecha=2)
    form_edicion("Modificar item", 'inventario.rb')
    puts pag.cgi.hidden("accion", "actualizar")
    puts pag.cgi.hidden('id', frm['id'])
    input_texto("Nombre:", 'nombre',  inventario.nombre)
    input_combo("Deposito:", "deposito_id", depositos, ['id', 'deposito'], inventario.deposito_id)
    input_fecha("Fecha de compra:", 'compra', inventario.compra)
    input_numero("Costo:", 'costo',  inventario.costo)
    input_numero('Vida útil:', 'vida',  inventario.vida)
    input_numero('Valor residual', 'residual',  inventario.residual)
    input_texto('Método de cálculo:', 'metodo',  inventario.metodo)
    input_numero('Revaluación:', 'revaluacion',  inventario.revaluacion)
    input_fecha2('Fecha de revaluación:', 'fecha_rev', inventario.fecha_rev)
    botones('inventario.rb?accion=listado')
    form_edicion_fin
    pag.fin
end
def actualizar(frm)
    compra = Fecha.new(frm['compra'], 'eu')
    fecha_rev = Fecha.new(frm['fecha_rev'], 'eu')
    Inventario.update(frm['id'],  {
        :nombre => frm['nombre'], 
        :deposito_id => frm['deposito_id'], 
        :compra => compra.us, 
        :costo => frm['costo'], 
        :vida => frm['vida'], 
        :residual => frm['residual'], 
        :metodo => frm['metodo'], 
        :revaluacion => frm['revaluacion'], 
        :fecha_rev => fecha_rev.us
    })
    listado(frm)
end
def recalcular(frm)
    inventario = Inventario.find(frm['id'])
    ahora = Fecha.new(hoy)
    if inventario.metodo == ''
        valor = 100
        Inventario.update(frm['id'], {
            :revaluacion=>valor, 
            :fecha_rev=>ahora.us})
    end
    listado(frm)
end
if __FILE__ == $0
    form = CGI.new('html4')
    accion = 'listado'
    if form.has_key?('accion')
        accion = form['accion']
    end
    case accion
    when 'listado'
        listado(form)
    when 'editar'
        editar(form)
    when 'actualizar'
        actualizar(form)
    when 'nuevo'
        nuevo(form)
    when 'agregar'
        agregar(form)
    when 'recalcular'
        recalcular(form)
    when 'eliminar'
        eliminar(form)
    end
end
