#!/usr/bin/env ruby
require 'cgi_exception'
require 'funciones'
require 'datos'
require 'cgi'
require 'htm'
def listado(frm)
    pag = Pagina.new('Llamadas telefónicas: completo', 10)
    clientes = Cliente.find(:all, :order=>:nombre)
    formulario('lla.rb')
    puts pag.cgi.hidden('accion', 'listado_filtrado')
    puts '<table><tr>'    
    celda("<label for='cliente_id'>Filtrar por cliente:</label>")
    puts "<td><select name='cliente_id' id='cliente_id'>"
    clientes.each do |fila|
        print "<option value='#{fila.id}'>#{fila.nombre}</option>"
    end
    puts '</select></td><td>'
    print pag.cgi.submit("Buscar")
    print '</td><td>'
    boton("Volver","geined.py?accion=recepcion")
    puts '</td></tr></table>'
    fin_formulario
    llamadas = Llamada.find(:all, :order=>'fecha DESC')
    encabezado_tabla(["Fecha", "Cliente", "Notas", "Acciones"])
    i = 0
    llamadas.each do |fila|
        fila_alterna(i)
        celda(mysql_a_fecha(fila.fecha))
        nombre = ""
        begin
            clientes = Cliente.find(fila.cliente_id)
            nombre = clientes.nombre
        rescue ActiveRecord::RecordNotFound
            nombre = "Desconocido"
        end
        celda(clientes.nombre) 
        celda(fila.notas)
        puts '<td>'
        boton_editar("lla.rb?accion=editar&id=#{fila.id}&cliente_id=#{fila.cliente_id}")
        boton_eliminar("lla.rb?accion=eliminar&id=#{fila.id}&cliente_id=#{fila.cliente_id}")
        puts '</td></tr>'
        i = i + 1
    end
    fin_tabla
    boton("Volver","geined.py?accion=recepcion")
    pag.fin
end
def listado_filtrado(frm)
    pag = Pagina.new('Llamadas telefónicas: por cliente', 10)
    cliente_id = frm['cliente_id']
    cliente = Cliente.find(cliente_id)
    puts pag.cgi.h2{"Cliente: #{cliente.nombre}."} + pag.cgi.h3{"Teléfono: #{cliente.telefono}."}
    boton('Nuevo', "lla.rb?accion=nuevo&cliente_id=#{cliente_id}")
    llamadas = Llamada.find(:all, :conditions=>{:cliente_id=>cliente_id}, :order=>'fecha DESC')
    encabezado_tabla(["Fecha", "Notas", "Acciones"])
    i = 0
    llamadas.each do |fila|
        fila_alterna(i)
        celda(mysql_a_fecha(fila.fecha))
        celda(fila.notas)
        puts '<td>'
        boton_editar("lla.rb?accion=editar&id=#{fila.id}&cliente_id=#{cliente_id}")
        boton_eliminar("lla.rb?accion=eliminar&id=#{fila.id}&cliente_id=#{cliente_id}")
        puts '</td></tr>'
        i = i + 1
    end
    fin_tabla
    boton("Volver al listado", "lla.rb")
    boton("Volver a recepción", "geined.py?accion=recepcion")
    boton("Volver al cliente","cli_ver.php?accion=listado&id=#{cliente_id}")
    pag.fin
end
def editar(frm)
  pag = Pagina.new('Edición de llamada telefónica', nivel=10, fecha=1)
  llamada = Llamada.find(frm['id'])
  cliente_id = frm['cliente_id']
  form_edicion('Editar llamada', 'lla.rb')
  puts pag.cgi.hidden('accion', 'actualizar') +
    pag.cgi.hidden('id', frm['id']) +
    pag.cgi.hidden('cliente_id', cliente_id)
  input_fecha('Fecha:', 'fecha', llamada.fecha)
  input_texto('Notas:', 'notas', llamada.notas)
  botones("lla.rb?accion=listado&cliente_id=#{cliente_id}")
  form_edicion_fin
  pag.fin
end
def actualizar(frm)
  pag = Pagina.new("Actualizando", 10)
  id = frm['id']
  cliente_id = frm['cliente_id']
  Llamada.update( cliente_id,
    :fecha => frm['fecha'],
    :notas => frm['notas'])
  frm.params['accion'] = 'listado'
  redirigir("lla.rb?accion=listado&cliente_id=#{cliente_id}")
end
def nuevo(frm)
  pag = Pagina.new('Nueva llamada', nivel=10, fecha=1)
  cliente_id = frm['cliente_id']
  form_edicion('Nueva llamada', 'lla.rb')
  puts pag.cgi.hidden('accion', 'agregar') +
    pag.cgi.hidden('cliente_id', cliente_id)
  input_fecha('Fecha:', 'fecha', fecha_a_mysql(hoy))
  input_texto('Notas:', 'notas', '')
  botones("lla.rb?accion=listado&cliente_id=#{cliente_id}")
  form_edicion_fin
  pag.fin
end
def agregar(frm)
    fecha = Fecha.new(frm['fecha'], 'eu')
    cliente_id = frm["cliente_id"]
    Llamada.create(
        :cliente_id => frm['cliente_id'],
        :fecha => fecha.us,
        :notas => frm['notas'])
    listado(frm)
end
if __FILE__ == $0
  form = CGI.new('html3')
  accion = 'listado'
  if form.has_key?('accion')
    accion = form['accion']
  end
  case accion
  when 'listado'
    if form.has_key?('cliente_id')
        listado_filtrado(form)
    else
      listado(form)
    end
  when 'listado_filtrado'
    if form.has_key?('cliente_id')
        listado_filtrado(form)
    else
        listado(form)
    end
  when 'editar'
    editar(form)
  when 'actualizar'
    actualizar(form)
  when 'nuevo'
    nuevo(form)
  when 'agregar'
    agregar(form)
  when 'eliminar'
    Llamada.delete(form['id'])
    listado(form)
  end
end
