#!/usr/bin/env ruby
# Mantenimiento de area contable
require 'cgi'
require 'cgi_exception'
require 'funciones'
require 'htm'
require 'datos'
# Listado de registros inválidos
def listado
    pag = Pagina.new('Listado de registros inválidos', 4)
    boton("Eliminar registros CERO", "mantenimiento.rb?accion=eliminar_ceros")
    boton("Volver", 'geined.py?accion=contabilidad')
    puts pag.cgi.h2{"Registros con 0 en debe y en haber"}
    transacciones = Transaccion.find(:all,
        :conditions=>{:debe=>0, :haber=>0},
        :order=>'id DESC')
    i = 0
    encabezado_tabla(["Nº", "Fecha", "Detalle", "Rubro", "Debe", "Haber", "Acciones"])
    transacciones.each do |fila|
        fila_alterna(i)
        celda(fila.id)
        celda(mysql_a_fecha(fila.fecha))
        celda(fila.detalle)
        begin
            cuenta = Cuenta.find(fila.cuenta_id)
            rubro = cuenta.rubro
        rescue ActiveRecord::RecordNotFound
            rubro = 'No encontrado'
        end
        celda(rubro)
        linea_moneda(fila.debe)
        linea_moneda(fila.haber)
        puts '<td>'
        boton_eliminar("mantenimiento.rb?accion=borrar&id=#{fila.id}")
        puts '</td></tr>'
        i = i + 1
    end
    fin_tabla
    puts "<br />"
    linea
    puts "<br />"
    puts pag.cgi.h2{"Registros con Rubro 0"}
    transacciones = Transaccion.find(:all,
        :conditions=> ["(cuenta_id=NULL) OR (cuenta_id=0)"],
        :order=>"id DESC")
    i = 0
    tot_debe = 0
    tot_haber = 0
    encabezado_tabla(["Nº", "Fecha", "Detalle", "Rubro", "Debe", "Haber", "Acciones"])
    transacciones.each do |fila|
        fila_alterna(i)
        celda(fila.id)
        celda(mysql_a_fecha(fila.fecha))
        celda(fila.detalle)
        begin
            cuenta = Cuenta.find(fila.cuenta_id)
            rubro = cuenta.rubro
        rescue ActiveRecord::RecordNotFound
            rubro = "No encontrado"
        end
        celda(rubro)
        linea_moneda(fila.debe)
        tot_debe = tot_debe + fila.debe
        linea_moneda(fila.haber)
        tot_haber = tot_haber + fila.haber
        puts '<td>'
        boton_detalles("mantenimiento.rb?accion=ver_asientos&id=#{fila.id}")
        puts '</td></tr>'
        i = i + 1
    end
    puts ('<tr>')
    celda("---")
    celda("---")
    celda("Total")
    celda("---")
    celda(moneda(tot_debe))
    celda(moneda(tot_haber))
    celda("---")
    puts ('</tr>')
    fin_tabla
    puts pag.cgi.h2{"Registros imputados a rubro incorrecto"}
    i = 0
    tot_debe = 0
    tot_haber = 0
    encabezado_tabla(["Nº", "Fecha", "Detalle", "Rubro", "Nombre", "Debe", "Haber", "Acciones"])
    begin
        cuentas = Cuenta.find(:all,
            :conditions => "nivel <> 0",
            :order => "rubro")
        cuentas.each do |fila|
            begin
                transacciones = Transaccion.find(:all,
                    :conditions => {:cuenta_id => fila.id},
                    :order => :id)
                transacciones.each do |item|
                    fila_alterna(i)
                    celda(item.id)
                    celda(mysql_a_fecha(item.fecha))
                    celda(item.detalle)
                    rubro = fila.rubro
                    celda(rubro)
                    celda(fila.nombre)
                    celda(moneda(item.debe))
                    tot_debe = tot_debe + item.debe
                    celda(moneda(item.haber))
                    tot_haber = tot_haber + item.haber
                    puts "<td>"
                    boton_detalles("mantenimiento.rb?accion=ver_asientos&id=#{item.id}")
                    puts "</td></tr>"
                    i = i + 1
                end
            rescue ActiveRecord::RecordNotFound
                a = 1
            end
        end
        print("<tr>")
        celda("---")
        celda("---")
        celda("Total")
        celda("---")
        celda("---")
        celda(moneda(tot_debe))
        celda(moneda(tot_haber))
        celda("---")
        puts("</tr>")
        fin_tabla
    rescue ActiveRecord::RecordNotFound
        puts "No se encontraron registros"
    end
    boton("Volver",'geined.py?accion=contabilidad')
    pag.fin
end
# Muestra un asiento doble en base a una ID de TRANSACCIONES
def ver_asientos(frm)
    if not frm.has_key?("id")
        error_parametros("mantenimiento.rb")
    else
        ident = frm["id"]
        pag = Pagina.new("Par de asientos inválidos", 4)
        transaccion = Transaccion.find(ident)
        detalle = transaccion.detalle
        begin
            transaccion = Transaccion.find(:all,
                :conditions => "detalle LIKE '#{detalle}%'",
                :order => :id)
            encontrado = true
        rescue ActiveRecord::RecordNotFound
            htm.h3("Registro/s no encontrado/s")
            htm.boton("Volver", "mantenimiento.rb?accion=listado")
            encontrado = false
        end
        if encontrado
            encabezado_tabla(["Nº", "Fecha", "Detalle", "Rubro", "Debe", "Haber", "Acciones"])
            i = 0
            transaccion.each do |fila|
                fila_alterna(i)
                celda(fila.id)
                celda(mysql_a_fecha(fila.fecha))
                celda(fila.detalle)
                begin
                    cuenta = Cuenta.find(fila.cuenta_id)
                    rubro = cuenta.rubro
                rescue ActiveRecord::RecordNotFound
                    rubro = "No encontrado"
                end
                celda(rubro)
                celda(moneda(fila.debe))
                celda(moneda(fila.haber))
                puts '<td>'
                boton("Editar","tra.rb?accion=editar&id=#{fila.id}")
                # Aun no esta implementado borrar_ambos
                boton("Borrar ambos","mantenimiento.rb?accion=borrar_ambos&id=#{ident}")
                puts '</td></tr>'
                i = i + 1
            end
            fin_tabla
            boton("Volver", "mantenimiento.rb?accion=listado")
        end
        pag.fin
    end
end
if __FILE__ == $0
    form = CGI.new('html4')
    accion = 'listado'
    if form.has_key?('accion')
        accion = form['accion']
    end
    case accion
    when 'listado'
        listado
    when 'borrar'
        Transaccion.delete(frm.id)
        listado
    when 'eliminar_ceros'
        Transaccion.delete_all("debe=0 AND haber=0")
        listado
    when 'ver_asientos'
        ver_asientos(form)
    else
        error_parametros("geined.py?accion=contabilidad")
    end
end
