#!/usr/bin/env python
# -*- coding: utf-8 -*-
"""Conjunto de rutinas para generar paginas htm"""
import htm
import Cookie
import os
class Pagina:
    """Clase para generar una pagina web"""
    def __init__(self, titulo, nivel=20, fecha=0, tipo="comun"):
        #tipos: comun, boleta, informe
        self.tipo = tipo
        self.sesion = Cookie.SimpleCookie(os.environ.get("HTTP_COOKIE",""))
        self.fecha = fecha
        accion = self.autorizacion(nivel)
        if accion == "login":
            htm.inicio()
            print('<META HTTP-EQUIV="Refresh" CONTENT="0;URL=Login.php">')
        elif accion == "noautorizado":
            htm.inicio()
            print('<META HTTP-EQUIV="Refresh" CONTENT="0;URL=no_autorizado.html">')
        else:
            self.titulo = titulo
            self.filas_por_pagina = 20
            self.encabezado(self.titulo)
    def estilo(self):
        """Agrega cadena que hace referencia a archivo css"""
        if self.tipo == "boleta":
            print('<link type="text/css" href="./css/boleta.css" rel="stylesheet" />')
        elif self.tipo == "informe":
            print('<link type="text/css" href="./css/greyscale.css" rel="stylesheet" />')
        else:
            print('<link type="text/css" href="./css/geinedpy.css" rel="stylesheet" />')
    def encabezado(self, titulo):
        """Encabezado de pagina web"""
        htm.inicio()
        print '<head>'
        print '<script type="text/javascript" src="geined.js" charset="utf-8"></script>'
        if self.tipo == "boleta":
            print(htm.title("Boleta"))
        else:
            print(htm.title(self.titulo))
        self.estilo()
        if self.fecha >= 1:
            print '<style type="text/css">@import url(./js/calendar-win2k-1.css);</style>'
            print '<script type="text/javascript" src="./js/calendar.js"></script>'
            print '<script type="text/javascript" src="./js/lang/calendar-es.js"></script>'
            print '<script type="text/javascript" src="./js/calendar-setup.js"></script>'
        #print '</head><body><div id="envoltura">'
        print '</head><body>'
        if self.tipo == "comun":
            print "<table class='tmenu'><tr>"
            print(htm.td(htm.img('./conf/logo.png')))
            #celda("<h1>" + titulo + "</h1>")
            #print "</tr>"
        if not self.sesion.has_key("deposito_id"):
            sucursal = "Sin asignar"
            deposito_id = 0
        else:
            if self.sesion["deposito_id"].value == "None":
                deposito_id = 1
            else:
                deposito_id = int(self.sesion['deposito_id'].value)
        if deposito_id == 1:
            sucursal = "Central"
        elif deposito_id == 2:
            sucursal = "Costa de Oro"
        elif deposito_id == 3:
            sucursal = "Carrasco"
        else:
            sucursal = "xxxx"
        if self.tipo == "comun":
            #celda(self.sesion["usuario"].value + " en " + sucursal, "d")
            #print "<tr><td>" + self.sesion["usuario"].value + "  en " + sucursal  +"</td>"
            print('<td align="right">')
            print("<a title='Inicio' href='geined.py'>")
            # print ("<img src='./img/inicio.png' width='32' height='32'></a>")
            print ("<img src='./img/inicio.png'></a>")
            print("<a title='Reportar un error o idea' href='des.py'> \
            <img src='./img/reportar.png'></a>")
            # TODO: ver si además hay que cambar suc en Python / Ruby
            print("<a title='Cambiar de sucursal' href='suc.php'> \
            <img src='./img/cambiar.png'></a>")
            print "</td></tr></table>"
            print("<table class='tmenu2'><tr><td align='left'>" + titulo + "</td>")
            print("<td align='right'>"+ self.sesion["usuario"].value + 
                " en " + sucursal +"</td></tr></table>")
    def fin(self):
        """Tags de finalizacion de una pagina"""
        if self.fecha >= 1:
            htm.script_fecha()
        if self.fecha >= 2:
            htm.script_fecha2()
        print('</body></html>')
    def autorizacion(self, niv):
        """Rutina para autorizar ingreso a una pagina"""
        # 20: cualquiera 10: docente 5: recepcion 4: Adriana
        # 3: Hassan / Leo 2: Mariana 1: Marcelo
        if not self.sesion.has_key("nivel"):
            # Imprime encabezado de pagina web
            return "login"
        else:
            nivel_sesion = int(self.sesion["nivel"].value)
            if nivel_sesion > niv:
                return "noautorizado"
def error_parametros(retorno):
    """Devuelve página con error en parámetros"""
    pag = Pagina("Error de parámetros", 20)
    print("Hay un error en los parámetros pasados<br />")
    print htm.button("Volver", retorno)
    pag.fin()
def error_variable(retorno):
    """Devuelve una página con el error"""
    pag = Pagina("Error de variables", 20)
    print "Faltan variables para realizar la operacion<br />"
    print htm.button("Volver", retorno)
    pag.fin()
def duplicado(retorno):
    """Devuelve una página con error de duplicado"""
    pag = Pagina("Registro duplicado", 20)
    print("El registro que intenta agregar ya existe<br />")
    print(htm.button("Volver", retorno))
    pag.fin()
def no_autorizado(retorno):
    """Pone pagina de acceso no autorizado"""
    pag = Pagina("Acceso no autorizado", 20)
    htm.nota('Usted no se encuentra autorizado para ver esta página')
    print htm.button('Volver', retorno)
    pag.fin()
